
<!DOCTYPE html>

<html>
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>DistributionPlots &#8212; Battery SOH  documentation</title>
    
  <link href="../_static/css/theme.css" rel="stylesheet" />
  <link href="../_static/css/index.c5995385ac14fb8791e8eb36b4908be2.css" rel="stylesheet" />

    
  <link rel="stylesheet"
    href="../_static/vendor/fontawesome/5.13.0/css/all.min.css">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-solid-900.woff2">
  <link rel="preload" as="font" type="font/woff2" crossorigin
    href="../_static/vendor/fontawesome/5.13.0/webfonts/fa-brands-400.woff2">

    
      

    
    <link rel="stylesheet" type="text/css" href="../_static/pygments.css" />
    <link rel="stylesheet" type="text/css" href="../_static/basic.css" />
    <link rel="stylesheet" type="text/css" href="../_static/css/custom.css" />
    
  <link rel="preload" as="script" href="../_static/js/index.1c5a1a01449ed65a7b51.js">

    <script data-url_root="../" id="documentation_options" src="../_static/documentation_options.js"></script>
    <script src="../_static/jquery.js"></script>
    <script src="../_static/underscore.js"></script>
    <script src="../_static/doctools.js"></script>
    <script crossorigin="anonymous" integrity="sha256-Ae2Vz/4ePdIu6ZyI/5ZGsYnb+m0JlOmKPjt6XZ9JJkA=" src="https://cdnjs.cloudflare.com/ajax/libs/require.js/2.3.4/require.min.js"></script>
    <link rel="index" title="Index" href="../genindex.html" />
    <link rel="search" title="Search" href="../search.html" />
    <meta name="viewport" content="width=device-width, initial-scale=1" />
    <meta name="docsearch:language" content="en" />
    
  </head>
  <body data-spy="scroll" data-target="#bd-toc-nav" data-offset="80">
    
    <div class="container-fluid" id="banner"></div>

    
    <nav class="navbar navbar-light navbar-expand-lg bg-light fixed-top bd-navbar" id="navbar-main"><div class="container-xl">

  <div id="navbar-start">
    
    

<a class="navbar-brand" href="../index.html">
  <img src="../_static/logo.png" class="logo" alt="logo">
</a>


    
  </div>

  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbar-collapsible" aria-controls="navbar-collapsible" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

  
  <div id="navbar-collapsible" class="col-lg-9 collapse navbar-collapse">
    <div id="navbar-center" class="mr-auto">
      
      <div class="navbar-center-item">
        <ul id="navbar-main-elements" class="navbar-nav">
    <li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Colabs.html">
  Google Colabs
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/main.html">
  Useful dictionaries
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Battery%20Classes.html">
  Battery Classes
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Cleaning.html">
  Treatment functions
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Models.html">
  Models
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Training.html">
  Training and Simulation
 </a>
</li>

<li class="toctree-l1 nav-item">
 <a class="reference internal nav-link" href="../sphinx/Report.html">
  Report related
 </a>
</li>

    
</ul>
      </div>
      
    </div>

    <div id="navbar-end">
      
      <div class="navbar-end-item">
        <ul id="navbar-icon-links" class="navbar-nav" aria-label="Icon Links">
      </ul>
      </div>
      
    </div>
  </div>
</div>
    </nav>
    

    <div class="container-xl">
      <div class="row">
          
            
            <!-- Only show if we have sidebars configured, else just a small margin  -->
            <div class="col-12 col-md-3 bd-sidebar"><form class="bd-search d-flex align-items-center" action="../search.html" method="get">
  <i class="icon fas fa-search"></i>
  <input type="search" class="form-control" name="q" id="search-input" placeholder="Search the docs ..." aria-label="Search the docs ..." autocomplete="off" >
</form><nav class="bd-links" id="bd-docs-nav" aria-label="Main navigation">
  <div class="bd-toc-item active">
    
  </div>
</nav>
            </div>
            
          

          
          <div class="d-none d-xl-block col-xl-2 bd-toc">
            
          </div>
          

          
          
            
          
          <main class="col-12 col-md-9 col-xl-7 py-md-5 pl-md-5 pr-md-4 bd-content" role="main">
              
              <div>
                
  <h1>Source code for DistributionPlots</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">torch</span> <span class="k">as</span> <span class="nn">th</span>
<span class="kn">from</span> <span class="nn">Nasa_Classes</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">from</span> <span class="nn">Coin_Classes</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">main</span>
<span class="kn">from</span> <span class="nn">LSTM</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">from</span> <span class="nn">MIT_Classes</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">seaborn</span> <span class="k">as</span> <span class="nn">sns</span>
<span class="n">sns</span><span class="o">.</span><span class="n">set</span><span class="p">()</span>
<span class="n">device</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">device</span><span class="p">(</span><span class="s1">&#39;cuda:0&#39;</span> <span class="k">if</span> <span class="n">th</span><span class="o">.</span><span class="n">cuda</span><span class="o">.</span><span class="n">is_available</span><span class="p">()</span> <span class="k">else</span> <span class="s1">&#39;cpu&#39;</span><span class="p">)</span>

<div class="viewcode-block" id="dataset_jointplot"><a class="viewcode-back" href="../sphinx/Report.html#DistributionPlots.dataset_jointplot">[docs]</a><span class="k">def</span> <span class="nf">dataset_jointplot</span><span class="p">(</span><span class="n">dataset_name</span><span class="p">,</span> <span class="n">full_dataset</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">,</span>
                      <span class="n">norm</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">norm_type</span><span class="o">=</span><span class="s1">&#39;zscore&#39;</span><span class="p">,</span> <span class="n">cycle_lim</span><span class="o">=</span><span class="mf">1e6</span><span class="p">,</span> <span class="n">delta</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                      <span class="n">lstm_version</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">batteries</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>

    <span class="sd">&quot;&quot;&quot;Function for creating joint plots of the different datasets.</span>

<span class="sd">    The joint plots consist of a 2D scatter plot of the (t, V) couples, with</span>
<span class="sd">    approximated distribution functions on the sides. An example is shown below.</span>

<span class="sd">    .. figure:: Images/B0047.png</span>
<span class="sd">        :alt: Example of a joint plot.</span>
<span class="sd">        :figwidth: 80 %</span>

<span class="sd">        Example of a joint plot.</span>

<span class="sd">    This function does not support mixing different datsets (for it, check</span>
<span class="sd">    ``dataset_displot``). This function can only create separate joint plots for</span>
<span class="sd">    one or many batteries of a same dataset.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    dataset_name : {&#39;NASA&#39;, &#39;MIT&#39;, &#39;Tarascon Coin&#39;}</span>
<span class="sd">        String indicating which dataset we want to create the joint plot of.</span>
<span class="sd">    full_dataset : bool</span>
<span class="sd">        Whether or not we want to create a joint plot of the whole dataset in</span>
<span class="sd">        one image (True) of one image for each battery (False).</span>
<span class="sd">    fixed_len : int, optional</span>
<span class="sd">        If different than `None` (default value), then the charge and discharge</span>
<span class="sd">        curves will be limited to `fixed_len` points.</span>
<span class="sd">    norm_type : {&#39;zscore&#39;, &#39;minmax&#39;}</span>
<span class="sd">        A string indicating which kind of normalization to do.</span>
<span class="sd">    norm : tuple(Tensor, Tensor, Tensor, Tensor, string), optional</span>
<span class="sd">        A tuple containing all of the information necessary for normalization.</span>
<span class="sd">        If entered as input, `norm_type` will be overridden by norm[4] and the</span>
<span class="sd">        given information will be used for the normalization</span>
<span class="sd">    cycle_lim : int, optional</span>
<span class="sd">        The greatest cycle number to take into account for the dataset creation.</span>
<span class="sd">        Default equals ``1e6`` meaning that no cycles will be ignored.</span>
<span class="sd">    delta : int, optional</span>
<span class="sd">        The size of the sliding window used to generate the x_i&#39;s.</span>
<span class="sd">        This value only needs to be updated if the given ``norm`` is not</span>
<span class="sd">        ``None``, in which case shapes and sizes have to agree.</span>
<span class="sd">        See ``Torch_Dataset_LSTM``&#39;s docstring in `LSTM.py` for more information.</span>
<span class="sd">    lstm_version : int, optional</span>
<span class="sd">        The LSTM&#39;s version used for creating the normalisation parameters</span>
<span class="sd">        (``norm``). This only needs to be given if ``norm`` is not ``None``.</span>
<span class="sd">    time_step : int, optional</span>
<span class="sd">        The desired time step for the resampling procedure.</span>
<span class="sd">        If ``None`` is given, than a time step will be automatically generated</span>
<span class="sd">        by the method ``time_step_function``.</span>
<span class="sd">    batteries : list[str], optional</span>
<span class="sd">        A list with the battery files&#39; names to create plots for. If ``None``,</span>
<span class="sd">        than all of the available batteries are used.</span>

<span class="sd">    Raises</span>
<span class="sd">    ------</span>
<span class="sd">    AssertionError</span>
<span class="sd">        If the given ``dataset_name`` is not one of the valid ones.</span>
<span class="sd">    TypeError</span>
<span class="sd">        If ``fixed_len`` is ``None``.</span>

<span class="sd">    Examples</span>
<span class="sd">    --------</span>
<span class="sd">    &gt;&gt;&gt; from DistributionPlots import *</span>
<span class="sd">    &gt;&gt;&gt; dataset_jointplot(&#39;NASA&#39;, batteries=[&#39;B0005.txt&#39;])</span>
<span class="sd">    32.532073974609375      # Calculated time step</span>
<span class="sd">    B0005                   # Battery currently analysing</span>
<span class="sd">    165                     # Number of capacity points</span>
<span class="sd">    # Plot saved in &#39;.//Datasets/NASA/B. Saha and K Goebel/Separate_pickles&#39;:</span>

<span class="sd">    .. figure:: Images/B0005.png</span>
<span class="sd">        :alt: The plot created</span>
<span class="sd">        :figwidth: 80 %</span>

<span class="sd">        Plot saved as &quot;B0005.png&quot;</span>

<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">if</span> <span class="n">batteries</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">batteries</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B&#39;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span><span class="o">+</span><span class="s1">&#39;.txt&#39;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">100</span><span class="p">)]</span>

    <span class="k">assert</span> <span class="n">dataset_name</span> <span class="ow">in</span> <span class="p">[</span><span class="s1">&#39;NASA&#39;</span><span class="p">,</span> <span class="s1">&#39;MIT&#39;</span><span class="p">,</span> <span class="s1">&#39;Tarascon Coin&#39;</span><span class="p">],</span> \
        <span class="s2">&quot;Invalid dataset name, valid dataset names are: &#39;NASA&#39;, &#39;MIT&#39; and &quot;</span> \
        <span class="s2">&quot;&#39;Tarascon Coin&#39;.&quot;</span>

    <span class="k">if</span> <span class="n">fixed_len</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="k">raise</span> <span class="ne">TypeError</span><span class="p">(</span><span class="s2">&quot;The following code only works for an integer fixed_len.&quot;</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">time_step</span> <span class="ow">is</span> <span class="kc">None</span> <span class="ow">and</span> <span class="ow">not</span> <span class="n">full_dataset</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;Can&#39;t use time_step None with full_dataset False.</span><span class="se">\n</span><span class="s2">&quot;</span><span class="p">)</span>
        <span class="n">string</span> <span class="o">=</span> <span class="s1">&#39;A&#39;</span>
        <span class="k">while</span> <span class="n">string</span><span class="o">.</span><span class="n">upper</span><span class="p">()</span> <span class="o">!=</span> <span class="s1">&#39;Y&#39;</span> <span class="ow">and</span> <span class="n">string</span><span class="o">.</span><span class="n">upper</span><span class="p">()</span> <span class="o">!=</span> <span class="s1">&#39;N&#39;</span><span class="p">:</span>
            <span class="n">string</span> <span class="o">=</span> <span class="nb">input</span><span class="p">(</span>
                <span class="s2">&quot;Do you wish to use the default time_step for this dataset &quot;</span>
                <span class="s2">&quot;( &quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="n">main</span><span class="o">.</span><span class="n">default_time_step_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">])</span><span class="o">+</span><span class="s2">&quot; )? [y/n]&quot;</span>
            <span class="p">)</span>

        <span class="k">if</span> <span class="n">string</span><span class="o">.</span><span class="n">upper</span><span class="p">()</span> <span class="o">==</span> <span class="s1">&#39;Y&#39;</span><span class="p">:</span>
            <span class="n">time_step</span> <span class="o">=</span> <span class="n">main</span><span class="o">.</span><span class="n">default_time_step_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">]</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">time_step</span> <span class="o">=</span> <span class="nb">float</span><span class="p">(</span><span class="nb">input</span><span class="p">(</span><span class="s2">&quot;Input the desired time step.&quot;</span><span class="p">))</span>

    <span class="c1"># Entering the dataset folder</span>
    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">main</span><span class="o">.</span><span class="n">path_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">])</span>
    <span class="n">ignore</span> <span class="o">=</span> <span class="n">main</span><span class="o">.</span><span class="n">ignore_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">]</span>

    <span class="c1"># Searching for battery files</span>
    <span class="n">files</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>    <span class="c1"># All files in the folder</span>
    <span class="n">file_list</span> <span class="o">=</span> <span class="p">[]</span>          <span class="c1"># List with the valid files</span>
    <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
        <span class="n">match</span> <span class="o">=</span> <span class="n">re</span><span class="o">.</span><span class="n">search</span><span class="p">(</span><span class="sa">r</span><span class="s1">&#39;B\d</span><span class="si">{4}</span><span class="s1">.txt&#39;</span><span class="p">,</span> <span class="n">file_name</span><span class="p">)</span>
        <span class="c1"># Only take into acount the battery files</span>
        <span class="k">if</span> <span class="n">match</span> <span class="o">==</span> <span class="kc">None</span><span class="p">:</span>
            <span class="k">continue</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">file_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">file_name</span><span class="p">)</span>
    <span class="n">file_list</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>

    <span class="n">dataset_list</span> <span class="o">=</span> <span class="p">[]</span>
    <span class="k">if</span> <span class="n">full_dataset</span><span class="p">:</span>    <span class="c1"># If we want  to do all of the batteries together:</span>
        <span class="c1"># Training files:</span>
        <span class="n">Train_list</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
            <span class="k">if</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">in</span> <span class="n">ignore</span><span class="p">)</span> <span class="ow">or</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">batteries</span><span class="p">):</span>
                <span class="k">continue</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

                <span class="n">Train_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

        <span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">(</span>
            <span class="n">Train_list</span><span class="p">,</span> <span class="n">delta</span><span class="p">,</span> <span class="n">lstm_version</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
            <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span> <span class="n">norm_type</span><span class="o">=</span><span class="n">norm_type</span><span class="p">,</span>
            <span class="n">adimensionalize</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">min_len</span><span class="o">=</span><span class="mi">150</span><span class="p">,</span> <span class="n">cycle_lim</span><span class="o">=</span><span class="n">cycle_lim</span><span class="p">,</span>
            <span class="n">norm</span><span class="o">=</span><span class="n">norm</span>
        <span class="p">)</span>
        <span class="n">dataset_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">train_dataset</span><span class="p">)</span>

    <span class="k">else</span><span class="p">:</span>
        <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
            <span class="k">if</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">in</span> <span class="n">ignore</span><span class="p">)</span> <span class="ow">or</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">batteries</span><span class="p">):</span>
                <span class="k">continue</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

                <span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">(</span>
                    <span class="p">[</span><span class="n">Battery</span><span class="p">],</span> <span class="n">delta</span><span class="p">,</span> <span class="n">lstm_version</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                    <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span>
                    <span class="n">norm_type</span><span class="o">=</span><span class="n">norm_type</span><span class="p">,</span> <span class="n">adimensionalize</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">min_len</span><span class="o">=</span><span class="mi">150</span><span class="p">,</span>
                    <span class="n">cycle_lim</span><span class="o">=</span><span class="n">cycle_lim</span><span class="p">,</span> <span class="n">norm</span><span class="o">=</span><span class="n">norm</span>
                <span class="p">)</span>
                <span class="n">dataset_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">train_dataset</span><span class="p">)</span>

    <span class="c1"># Creating the dataframe from the data</span>
    <span class="k">for</span> <span class="n">dataset</span> <span class="ow">in</span> <span class="n">dataset_list</span><span class="p">:</span>
        <span class="c1"># Current and Voltage information</span>
        <span class="n">nb</span> <span class="o">=</span> <span class="o">-</span><span class="mi">1</span>     <span class="c1"># The amount of cycles to take into account, -1 is all of them.</span>
        <span class="n">inputs</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">stack</span><span class="p">(</span><span class="n">dataset</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>     <span class="c1"># The input tensors</span>
        <span class="n">I</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[:</span><span class="n">nb</span><span class="p">,</span> <span class="p">:,</span> <span class="mi">0</span><span class="p">]</span>                       <span class="c1"># Selecting only the Current</span>
        <span class="n">V</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[:</span><span class="n">nb</span><span class="p">,</span> <span class="p">:,</span> <span class="n">delta</span><span class="p">]</span>                   <span class="c1"># Selecting only the Voltage</span>
        <span class="n">I</span> <span class="o">=</span> <span class="n">I</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">I</span><span class="p">)</span><span class="o">*</span><span class="n">fixed_len</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span><span class="o">.</span><span class="n">numpy</span><span class="p">()</span>           <span class="c1"># Turning them into np arrays</span>
        <span class="n">V</span> <span class="o">=</span> <span class="n">V</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">V</span><span class="p">)</span><span class="o">*</span><span class="n">fixed_len</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span><span class="o">.</span><span class="n">numpy</span><span class="p">()</span>           <span class="c1"># of the correct shape</span>

        <span class="c1"># Create the correct &quot;time&quot; numbering column</span>
        <span class="n">lin_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">fixed_len</span><span class="p">,</span> <span class="n">num</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">)</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="n">fixed_len</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
        <span class="n">t</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">tile</span><span class="p">(</span><span class="n">lin_array</span><span class="p">,</span> <span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">I</span><span class="p">)</span><span class="o">/</span><span class="n">fixed_len</span><span class="p">),</span> <span class="mi">1</span><span class="p">))</span>

        <span class="c1"># Dataset Name Column</span>
        <span class="n">Name</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">dataset_name</span><span class="p">]</span><span class="o">*</span><span class="nb">len</span><span class="p">(</span><span class="n">I</span><span class="p">))</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">I</span><span class="p">),</span> <span class="mi">1</span><span class="p">)</span>
        <span class="n">df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">(</span><span class="n">data</span><span class="o">=</span><span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">t</span><span class="p">,</span> <span class="n">I</span><span class="p">,</span> <span class="n">V</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">),</span>
                          <span class="n">columns</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;t&#39;</span><span class="p">,</span> <span class="s1">&#39;I&#39;</span><span class="p">,</span> <span class="s1">&#39;V&#39;</span><span class="p">])</span>

        <span class="n">df</span><span class="p">[</span><span class="s1">&#39;Name&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">Name</span>       <span class="c1"># I&#39;ve added this separately because otherwise the pd.df</span>
                                <span class="c1"># would become of type string.</span>

        <span class="c1"># Creating the joint plot:</span>
        <span class="n">sns_plot</span> <span class="o">=</span> <span class="n">sns</span><span class="o">.</span><span class="n">jointplot</span><span class="p">(</span>
            <span class="n">data</span><span class="o">=</span><span class="n">df</span><span class="p">,</span> <span class="n">x</span><span class="o">=</span><span class="s1">&#39;t&#39;</span><span class="p">,</span> <span class="n">y</span><span class="o">=</span><span class="s1">&#39;V&#39;</span><span class="p">,</span> <span class="n">hue</span><span class="o">=</span><span class="s1">&#39;Name&#39;</span><span class="p">,</span> <span class="n">palette</span><span class="o">=</span><span class="n">main</span><span class="o">.</span><span class="n">palette</span><span class="p">,</span> <span class="n">height</span><span class="o">=</span><span class="mi">10</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s1">&#39;+&#39;</span><span class="p">,</span>
            <span class="c1"># stat=&#39;density&#39;,</span>
            <span class="c1"># common_norm=False,</span>
            <span class="c1"># kind=&#39;kde&#39;,</span>
        <span class="p">)</span>

        <span class="c1"># Defining the plot title and saving the image.</span>
        <span class="c1"># Note that the image will be saved in the correspondingn dataset folder.</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">dataset</span><span class="o">.</span><span class="n">batteries</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="n">dataset</span><span class="o">.</span><span class="n">batteries</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
            <span class="n">image_name</span> <span class="o">=</span> <span class="n">dataset</span><span class="o">.</span><span class="n">batteries</span><span class="p">[</span><span class="mi">0</span><span class="p">][:</span><span class="o">-</span><span class="mi">4</span><span class="p">]</span> <span class="o">+</span> <span class="s1">&#39;.png&#39;</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="n">dataset_name</span><span class="p">)</span>
            <span class="n">image_name</span> <span class="o">=</span> <span class="n">dataset_name</span> <span class="o">+</span> <span class="s1">&#39;_joint_dist.png&#39;</span>

        <span class="n">sns_plot</span><span class="o">.</span><span class="n">savefig</span><span class="p">(</span><span class="n">image_name</span><span class="p">)</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">close</span><span class="p">()</span>

    <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../../../&#39;</span><span class="p">)</span></div>

<div class="viewcode-block" id="dataset_displot"><a class="viewcode-back" href="../sphinx/Report.html#DistributionPlots.dataset_displot">[docs]</a><span class="k">def</span> <span class="nf">dataset_displot</span><span class="p">(</span><span class="n">battery_lists</span><span class="o">=</span><span class="p">[</span><span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">],</span> <span class="n">twoD</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                    <span class="n">norm_list</span><span class="o">=</span><span class="p">[</span><span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">],</span> <span class="n">delta</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">lstm_version</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                    <span class="n">norm_type</span><span class="o">=</span><span class="s1">&#39;zscore&#39;</span><span class="p">,</span> <span class="n">cycle_lim</span><span class="o">=</span><span class="mf">1e6</span><span class="p">,</span>
                    <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">kind</span><span class="o">=</span><span class="s1">&#39;hist&#39;</span><span class="p">,</span>
                    <span class="n">image_name</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">ignore_dict</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">yscale</span><span class="o">=</span><span class="s1">&#39;linear&#39;</span><span class="p">):</span>

    <span class="sd">&quot;&quot;&quot;Function for creating histogram distributions of the different datasets.</span>

<span class="sd">    This function creates histograms and contour plots for comparing the</span>
<span class="sd">    different datasets&#39; distributions.</span>

<span class="sd">    .. figure:: Images/Figure_4.png</span>
<span class="sd">        :figwidth: 80 %</span>
<span class="sd">        :alt: Example of an histogram plot (``kind = &#39;hist&#39;``, ``twoD=False``)</span>

<span class="sd">        Example of an histogram plot (``kind = &#39;hist&#39;``, ``twoD=False``)</span>

<span class="sd">    .. figure:: Images/Figure_3.png</span>
<span class="sd">        :figwidth: 80 %</span>
<span class="sd">        :alt: Example of a countour plot (``kind = &#39;kde&#39;``, ``twoD=True``)</span>

<span class="sd">        Example of a countour plot (``kind = &#39;kde&#39;``, ``twoD=True``)</span>

<span class="sd">    It takes as inputs a list of lists with the batteries to include in the</span>
<span class="sd">    histograms. It should be structured as follows:</span>

<span class="sd">    .. code-block::</span>

<span class="sd">        battery_lists = [</span>
<span class="sd">            [&#39;B0005.txt&#39;, &#39;B0006.txt&#39;],     # Nasa Batteries</span>
<span class="sd">            [&#39;B0047.txt&#39;],                  # MIT Batteries</span>
<span class="sd">            [&#39;B0001.txt&#39;, &#39;B0004.txt&#39;]      # Tarascon&#39;s Coin Batteries</span>
<span class="sd">        ]</span>

<span class="sd">    If all of the dataset&#39;s batteries are to be used, then a simple ``None``</span>
<span class="sd">    can be passed instead of a list. **If no batteries are to be used, an emtpy</span>
<span class="sd">    list must be passed**.</span>

<span class="sd">    .. code-block::</span>

<span class="sd">        battery_lists = [</span>
<span class="sd">            None,                           # ALL of Nasa&#39;s Batteries</span>
<span class="sd">            [],                             # None of MIT Batteries</span>
<span class="sd">            [&#39;B0001.txt&#39;, &#39;B0004.txt&#39;]      # Tarascon&#39;s Coin Batteries</span>
<span class="sd">        ]</span>

<span class="sd">    By default, each dataset is normalized separately on its own. If you want to</span>
<span class="sd">    specify the normalisation parameters, you can use input ``norm_list`` for</span>
<span class="sd">    that:</span>

<span class="sd">    .. code-block::</span>

<span class="sd">        norm_nasa = (th.Tensor([1.9, 4.3]), th.Tensor([0.01, 0.4]),</span>
<span class="sd">                     th.Tensor([0.8]), th.Tensor([0.04]), &#39;zscore&#39;)</span>
<span class="sd">        norm_list = [</span>
<span class="sd">            norm_nasa,      # Nasa dataset will be normalised with norm_nasa</span>
<span class="sd">            None,           # MIT dataset will be normalised with respect to itself</span>
<span class="sd">            None            # Same as MIT for Tarascon&#39;s Coin batteries.</span>
<span class="sd">        ]</span>

<span class="sd">    .. note::</span>
<span class="sd">        Make sure the value of ``delta`` and ``lstm_version`` are in accordance</span>
<span class="sd">        with the normalisation information provided.</span>

<span class="sd">    .. note::</span>
<span class="sd">        When inputting a ``norm`` in ``norm_list``, the input ``norm_type`` will</span>
<span class="sd">        automatically be overridden by ``Torch_Dataset_LSTM``, but only for the</span>
<span class="sd">        dataset for which the normalisation parameters were specified.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    battery_lists : list[list[str]], optional</span>
<span class="sd">        List with three lists (of strings). The first list corresponds to the</span>
<span class="sd">        batteries for the Nasa dataset, the second one for the MIT dataset and</span>
<span class="sd">        the last one for Tarascon&#39;s Coin dataset.</span>
<span class="sd">        Each list is composed of several strings with the name of the battery</span>
<span class="sd">        files, in the format &quot;B0025.txt&quot; (``&#39;B&#39;+str(number).zfill(4)+&#39;.txt&#39;``).</span>

<span class="sd">        By default, it will use all of the available batteries for all datasets.</span>
<span class="sd">    twoD : bool</span>
<span class="sd">        Whether or not to create a 2D distribution (V x t).</span>
<span class="sd">    norm_list : list[tuple]</span>
<span class="sd">        A list with the normalisation information for each dataset.</span>
<span class="sd">        See function ``Normalize`` in ``Cleaning.py`` for more information on</span>
<span class="sd">        how this information is structured.</span>
<span class="sd">    norm_type : {&#39;zscore&#39;, &#39;minmax&#39;}</span>
<span class="sd">        A string indicating which kind of normalization to do.</span>
<span class="sd">    cycle_lim : int, optional</span>
<span class="sd">        The greatest cycle number to take into account for the dataset creation.</span>
<span class="sd">        Default equals ``1e6`` meaning that no cycles will be ignored.</span>
<span class="sd">    fixed_len : int, optional</span>
<span class="sd">        If different than `None` (default value), then the charge and discharge</span>
<span class="sd">        curves will be limited to `fixed_len` points.</span>
<span class="sd">    kind : str, default = &#39;hist&#39;</span>
<span class="sd">        The kind of seaborn plot to create. Check seaborn&#39;s ``displot``</span>
<span class="sd">        documentation for more information.</span>
<span class="sd">    image_name : str, optional</span>
<span class="sd">        If an image_name is given, then the image will be saved as a png file</span>
<span class="sd">        with that name.</span>
<span class="sd">    yscale : str, default = &#39;linear&#39;</span>
<span class="sd">        The y-axis scale (&#39;linear&#39; is regular and &#39;log&#39; for log scale&#39;).</span>
<span class="sd">    </span>
<span class="sd">    Examples</span>
<span class="sd">    --------</span>
<span class="sd">    &gt;&gt;&gt; from DistributionPlots import *</span>
<span class="sd">    &gt;&gt;&gt; dataset_displot(battery_lists=[[&#39;B0005.txt&#39;], [], None])</span>
<span class="sd">    ... # Nasa&#39;s Battery Nº5, no batteries from MIT&#39;s dataset, All of Tarascon&#39;s</span>
<span class="sd">    ... # batteries</span>
<span class="sd">    ... # See Figure 3_ for results</span>

<span class="sd">    &gt;&gt;&gt; os.chdir(&#39;.//Reports/2021-07-12 09_28_11.807309&#39;)</span>
<span class="sd">    &gt;&gt;&gt; # LSTM_v4 trained with Nasa dataset</span>
<span class="sd">    &gt;&gt;&gt; with open(&#39;best_model.txt&#39;, &#39;rb&#39;) as f:</span>
<span class="sd">    ...     Model = pickle.load(f)</span>
<span class="sd">    ...</span>
<span class="sd">    &gt;&gt;&gt; nasa_norm = Model.norm      # Taking the model&#39;s norm</span>
<span class="sd">    &gt;&gt;&gt; dataset_displot(battery_lists=[</span>
<span class="sd">    ...      [&#39;B0005.txt&#39;], [&#39;B0047.txt&#39;], [&#39;B0001.txt&#39;]</span>
<span class="sd">    ... ], twoD=True, kind=&#39;kde&#39;,</span>
<span class="sd">    ... norm_list=[nasa_norm, nasa_norm, nasa_norm], # datasets normalized with the same norm</span>
<span class="sd">    ... lstm_version=4, delta=10) # LSTM version and delta have to match the norm&#39;s.</span>
<span class="sd">    ... # See Figure 4 for results</span>

<span class="sd">    .. _Figure 3:</span>

<span class="sd">    .. figure:: Images/Figure_1.png</span>
<span class="sd">        :figwidth: 80 %</span>

<span class="sd">        Figure 3: Result of first example.</span>

<span class="sd">    .. _Figure 4:</span>

<span class="sd">    .. figure:: Images/Figure_2.png</span>
<span class="sd">        :figwidth: 80 %</span>

<span class="sd">        Figure 4: Result of the second example.</span>

<span class="sd">    &quot;&quot;&quot;</span>

    <span class="k">for</span> <span class="n">index</span><span class="p">,</span> <span class="n">entry</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">battery_lists</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">entry</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">battery_lists</span><span class="p">[</span><span class="n">index</span><span class="p">]</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;.txt&#39;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">100</span><span class="p">)]</span>

    <span class="n">lin_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="n">fixed_len</span><span class="p">,</span> <span class="n">num</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">)</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="n">fixed_len</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span>
    <span class="n">t_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([[</span><span class="mf">1.</span><span class="p">]])</span>
    <span class="n">I_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([[</span><span class="mf">1.</span><span class="p">]])</span>
    <span class="n">V_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([[</span><span class="mf">1.</span><span class="p">]])</span>
    <span class="n">Name_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([[</span><span class="mf">1.</span><span class="p">]])</span>

    <span class="k">if</span> <span class="n">ignore_dict</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">ignore_dict</span> <span class="o">=</span> <span class="n">main</span><span class="o">.</span><span class="n">ignore_dict</span>

    <span class="k">for</span> <span class="n">index</span><span class="p">,</span> <span class="n">batteries</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">battery_lists</span><span class="p">):</span>

        <span class="n">dataset_name</span> <span class="o">=</span> <span class="n">main</span><span class="o">.</span><span class="n">dataset_dict</span><span class="p">[</span><span class="n">index</span><span class="p">]</span>

        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">main</span><span class="o">.</span><span class="n">path_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">])</span>
        <span class="n">ignore</span> <span class="o">=</span> <span class="n">ignore_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">]</span>

        <span class="nb">print</span><span class="p">(</span><span class="n">dataset_name</span><span class="p">)</span>

        <span class="n">file_list</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>
        <span class="n">file_list</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>
        <span class="n">Train_list</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
            <span class="k">if</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">in</span> <span class="n">ignore</span><span class="p">)</span> <span class="ow">or</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">batteries</span><span class="p">):</span>
                <span class="k">continue</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

                <span class="n">Train_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../../../&#39;</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">Train_list</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
            <span class="k">continue</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">(</span>
                <span class="n">Train_list</span><span class="p">,</span> <span class="n">delta</span><span class="p">,</span> <span class="n">lstm_version</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span> <span class="n">norm_type</span><span class="o">=</span><span class="n">norm_type</span><span class="p">,</span>
                <span class="n">adimensionalize</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">min_len</span><span class="o">=</span><span class="mi">150</span><span class="p">,</span> <span class="n">cycle_lim</span><span class="o">=</span><span class="n">cycle_lim</span><span class="p">,</span>
                <span class="n">norm</span><span class="o">=</span><span class="n">norm_list</span><span class="p">[</span><span class="n">index</span><span class="p">]</span>
            <span class="p">)</span>

        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;norm =&quot;</span><span class="p">,</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">)</span>
        <span class="c1"># print(train_dataset.norm)</span>
        <span class="n">nb</span> <span class="o">=</span> <span class="o">-</span><span class="mi">1</span>  <span class="c1"># The amount of cycles to take into account, -1 is all of them.</span>
        <span class="n">inputs</span> <span class="o">=</span> <span class="n">th</span><span class="o">.</span><span class="n">stack</span><span class="p">(</span><span class="n">train_dataset</span><span class="o">.</span><span class="n">inputs</span><span class="p">)</span>  <span class="c1"># The input tensors</span>
        <span class="n">I</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[:</span><span class="n">nb</span><span class="p">,</span> <span class="p">:,</span> <span class="mi">0</span><span class="p">]</span>  <span class="c1"># Selecting only the Current</span>
        <span class="n">V</span> <span class="o">=</span> <span class="n">inputs</span><span class="p">[:</span><span class="n">nb</span><span class="p">,</span> <span class="p">:,</span> <span class="n">delta</span><span class="p">]</span>  <span class="c1"># Selecting only the Voltage</span>
        <span class="n">I</span> <span class="o">=</span> <span class="n">I</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">I</span><span class="p">)</span> <span class="o">*</span> <span class="n">fixed_len</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span><span class="o">.</span><span class="n">numpy</span><span class="p">()</span>  <span class="c1"># Turning them into np arrays</span>
        <span class="n">V</span> <span class="o">=</span> <span class="n">V</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">V</span><span class="p">)</span> <span class="o">*</span> <span class="n">fixed_len</span><span class="p">,</span> <span class="mi">1</span><span class="p">)</span><span class="o">.</span><span class="n">numpy</span><span class="p">()</span>  <span class="c1"># of the correct shape</span>

        <span class="c1"># Create the correct &quot;time&quot; numbering column</span>
        <span class="n">t</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">tile</span><span class="p">(</span><span class="n">lin_array</span><span class="p">,</span> <span class="p">(</span><span class="nb">int</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">I</span><span class="p">)</span> <span class="o">/</span> <span class="n">fixed_len</span><span class="p">),</span> <span class="mi">1</span><span class="p">))</span>
        <span class="c1"># Dataset Name Column</span>
        <span class="n">Name</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">dataset_name</span><span class="p">]</span> <span class="o">*</span> <span class="nb">len</span><span class="p">(</span><span class="n">I</span><span class="p">))</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">I</span><span class="p">),</span> <span class="mi">1</span><span class="p">)</span>

        <span class="n">t_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">t_array</span><span class="p">,</span> <span class="n">t</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
        <span class="n">I_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">I_array</span><span class="p">,</span> <span class="n">I</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
        <span class="n">V_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">V_array</span><span class="p">,</span> <span class="n">V</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
        <span class="n">Name_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">Name_array</span><span class="p">,</span> <span class="n">Name</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>

    <span class="n">data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">t_array</span><span class="p">[</span><span class="mi">1</span><span class="p">:,</span> <span class="p">:],</span>
                           <span class="n">I_array</span><span class="p">[</span><span class="mi">1</span><span class="p">:,</span> <span class="p">:],</span>
                           <span class="n">V_array</span><span class="p">[</span><span class="mi">1</span><span class="p">:,</span> <span class="p">:]],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>

    <span class="n">df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">(</span><span class="n">data</span><span class="o">=</span><span class="n">data</span><span class="p">,</span> <span class="n">columns</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;t&#39;</span><span class="p">,</span> <span class="s1">&#39;I&#39;</span><span class="p">,</span> <span class="s1">&#39;V&#39;</span><span class="p">])</span>
    <span class="n">df</span><span class="p">[</span><span class="s1">&#39;Name&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">Name_array</span><span class="p">[</span><span class="mi">1</span><span class="p">:,</span> <span class="p">:]</span>
    <span class="c1"># I&#39;ve added this separately because otherwise the pd.df would be str</span>

    <span class="c1"># Palette to differentiate between datasets (arbitrary):</span>

    <span class="k">if</span> <span class="n">twoD</span><span class="p">:</span>
        <span class="n">sns_plot</span> <span class="o">=</span> <span class="n">sns</span><span class="o">.</span><span class="n">displot</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">x</span><span class="o">=</span><span class="s1">&#39;t&#39;</span><span class="p">,</span>
                               <span class="n">y</span><span class="o">=</span><span class="s1">&#39;V&#39;</span><span class="p">,</span>
                               <span class="n">hue</span><span class="o">=</span><span class="s1">&#39;Name&#39;</span><span class="p">,</span> <span class="n">palette</span><span class="o">=</span><span class="n">main</span><span class="o">.</span><span class="n">palette</span><span class="p">,</span>
                               <span class="n">kind</span><span class="o">=</span><span class="n">kind</span><span class="p">,</span>
                               <span class="n">height</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span>
                               <span class="c1">#    binwidth=0.2,</span>
                               <span class="n">stat</span><span class="o">=</span><span class="s1">&#39;density&#39;</span><span class="p">,</span> <span class="n">common_norm</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">sns_plot</span> <span class="o">=</span> <span class="n">sns</span><span class="o">.</span><span class="n">displot</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">x</span><span class="o">=</span><span class="s1">&#39;V&#39;</span><span class="p">,</span>
                               <span class="n">hue</span><span class="o">=</span><span class="s1">&#39;Name&#39;</span><span class="p">,</span> <span class="n">palette</span><span class="o">=</span><span class="n">main</span><span class="o">.</span><span class="n">palette</span><span class="p">,</span>
                               <span class="n">kind</span><span class="o">=</span><span class="n">kind</span><span class="p">,</span>
                               <span class="n">height</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span>
                               <span class="n">aspect</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span>
                               <span class="c1">#    binwidth=0.2,</span>
                               <span class="n">stat</span><span class="o">=</span><span class="s1">&#39;density&#39;</span><span class="p">,</span> <span class="n">common_norm</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>

        <span class="n">plt</span><span class="o">.</span><span class="n">yscale</span><span class="p">(</span><span class="n">yscale</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">image_name</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">sns_plot</span><span class="o">.</span><span class="n">savefig</span><span class="p">(</span><span class="n">image_name</span><span class="o">+</span><span class="s1">&#39;.png&#39;</span><span class="p">)</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">close</span><span class="p">()</span></div>


<div class="viewcode-block" id="SOH_displot"><a class="viewcode-back" href="../sphinx/Report.html#DistributionPlots.SOH_displot">[docs]</a><span class="k">def</span> <span class="nf">SOH_displot</span><span class="p">(</span><span class="n">battery_lists</span><span class="o">=</span><span class="p">[</span><span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">],</span> <span class="n">twoD</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
                <span class="n">norm_list</span><span class="o">=</span><span class="p">[</span><span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">,</span> <span class="kc">None</span><span class="p">],</span> <span class="n">delta</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span> <span class="n">lstm_version</span><span class="o">=</span><span class="mi">1</span><span class="p">,</span>
                <span class="n">norm_type</span><span class="o">=</span><span class="s1">&#39;zscore&#39;</span><span class="p">,</span> <span class="n">cycle_lim</span><span class="o">=</span><span class="mf">1e6</span><span class="p">,</span>
                <span class="n">fixed_len</span><span class="o">=</span><span class="mi">150</span><span class="p">,</span> <span class="n">time_step</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">kind</span><span class="o">=</span><span class="s1">&#39;hist&#39;</span><span class="p">,</span>
                <span class="n">image_name</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">ignore_dict</span><span class="o">=</span><span class="kc">None</span><span class="p">):</span>

    <span class="sd">&quot;&quot;&quot;Function for creating histogram distributions of the different datasets.</span>

<span class="sd">    This function creates histograms and contour plots for comparing the</span>
<span class="sd">    different datasets&#39; distributions.</span>

<span class="sd">    .. figure:: Images/Figure_4.png</span>
<span class="sd">        :figwidth: 80 %</span>
<span class="sd">        :alt: Example of an histogram plot (``kind = &#39;hist&#39;``, ``twoD=False``)</span>

<span class="sd">        Example of an histogram plot (``kind = &#39;hist&#39;``, ``twoD=False``)</span>

<span class="sd">    .. figure:: Images/Figure_3.png</span>
<span class="sd">        :figwidth: 80 %</span>
<span class="sd">        :alt: Example of a countour plot (``kind = &#39;kde&#39;``, ``twoD=True``)</span>

<span class="sd">        Example of a countour plot (``kind = &#39;kde&#39;``, ``twoD=True``)</span>

<span class="sd">    It takes as inputs a list of lists with the batteries to include in the</span>
<span class="sd">    histograms. It should be structured as follows:</span>

<span class="sd">    .. code-block::</span>

<span class="sd">        battery_lists = [</span>
<span class="sd">            [&#39;B0005.txt&#39;, &#39;B0006.txt&#39;],     # Nasa Batteries</span>
<span class="sd">            [&#39;B0047.txt&#39;],                  # MIT Batteries</span>
<span class="sd">            [&#39;B0001.txt&#39;, &#39;B0004.txt&#39;]      # Tarascon&#39;s Coin Batteries</span>
<span class="sd">        ]</span>

<span class="sd">    If all of the dataset&#39;s batteries are to be used, then a simple ``None``</span>
<span class="sd">    can be passed instead of a list. **If no batteries are to be used, an emtpy</span>
<span class="sd">    list must be passed**.</span>

<span class="sd">    .. code-block::</span>

<span class="sd">        battery_lists = [</span>
<span class="sd">            None,                           # ALL of Nasa&#39;s Batteries</span>
<span class="sd">            [],                             # None of MIT Batteries</span>
<span class="sd">            [&#39;B0001.txt&#39;, &#39;B0004.txt&#39;]      # Tarascon&#39;s Coin Batteries</span>
<span class="sd">        ]</span>

<span class="sd">    By default, each dataset is normalized separately on its own. If you want to</span>
<span class="sd">    specify the normalisation parameters, you can use input ``norm_list`` for</span>
<span class="sd">    that:</span>

<span class="sd">    .. code-block::</span>

<span class="sd">        norm_nasa = (th.Tensor([1.9, 4.3]), th.Tensor([0.01, 0.4]),</span>
<span class="sd">                     th.Tensor([0.8]), th.Tensor([0.04]), &#39;zscore&#39;)</span>
<span class="sd">        norm_list = [</span>
<span class="sd">            norm_nasa,      # Nasa dataset will be normalised with norm_nasa</span>
<span class="sd">            None,           # MIT dataset will be normalised with respect to itself</span>
<span class="sd">            None            # Same as MIT for Tarascon&#39;s Coin batteries.</span>
<span class="sd">        ]</span>

<span class="sd">    .. note::</span>
<span class="sd">        Make sure the value of ``delta`` and ``lstm_version`` are in accordance</span>
<span class="sd">        with the normalisation information provided.</span>

<span class="sd">    .. note::</span>
<span class="sd">        When inputting a ``norm`` in ``norm_list``, the input ``norm_type`` will</span>
<span class="sd">        automatically be overridden by ``Torch_Dataset_LSTM``, but only for the</span>
<span class="sd">        dataset for which the normalisation parameters were specified.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    battery_lists : list[list[str]], optional</span>
<span class="sd">        List with three lists (of strings). The first list corresponds to the</span>
<span class="sd">        batteries for the Nasa dataset, the second one for the MIT dataset and</span>
<span class="sd">        the last one for Tarascon&#39;s Coin dataset.</span>
<span class="sd">        Each list is composed of several strings with the name of the battery</span>
<span class="sd">        files, in the format &quot;B0025.txt&quot; (``&#39;B&#39;+str(number).zfill(4)+&#39;.txt&#39;``).</span>

<span class="sd">        By default, it will use all of the available batteries for all datasets.</span>
<span class="sd">    twoD : bool</span>
<span class="sd">        Whether or not to create a 2D distribution (V x t).</span>
<span class="sd">    norm_list : list[tuple]</span>
<span class="sd">        A list with the normalisation information for each dataset.</span>
<span class="sd">        See function ``Normalize`` in ``Cleaning.py`` for more information on</span>
<span class="sd">        how this information is structured.</span>
<span class="sd">    norm_type : {&#39;zscore&#39;, &#39;minmax&#39;}</span>
<span class="sd">        A string indicating which kind of normalization to do.</span>
<span class="sd">    cycle_lim : int, optional</span>
<span class="sd">        The greatest cycle number to take into account for the dataset creation.</span>
<span class="sd">        Default equals ``1e6`` meaning that no cycles will be ignored.</span>
<span class="sd">    fixed_len : int, optional</span>
<span class="sd">        If different than `None` (default value), then the charge and discharge</span>
<span class="sd">        curves will be limited to `fixed_len` points.</span>
<span class="sd">    kind : str, default = &#39;hist&#39;</span>
<span class="sd">        The kind of seaborn plot to create. Check seaborn&#39;s ``displot``</span>
<span class="sd">        documentation for more information.</span>
<span class="sd">    image_name : str, optional</span>
<span class="sd">        If an image_name is given, then the image will be saved as a png file</span>
<span class="sd">        with that name.</span>

<span class="sd">    Examples</span>
<span class="sd">    --------</span>
<span class="sd">    &gt;&gt;&gt; from DistributionPlots import *</span>
<span class="sd">    &gt;&gt;&gt; dataset_displot(battery_lists=[[&#39;B0005.txt&#39;], [], None])</span>
<span class="sd">    ... # Nasa&#39;s Battery Nº5, no batteries from MIT&#39;s dataset, All of Tarascon&#39;s</span>
<span class="sd">    ... # batteries</span>
<span class="sd">    ... # See Figure 1 for results</span>

<span class="sd">    &gt;&gt;&gt; os.chdir(&#39;.//Reports/2021-07-12 09_28_11.807309&#39;)</span>
<span class="sd">    &gt;&gt;&gt; # LSTM_v4 trained with Nasa dataset</span>
<span class="sd">    &gt;&gt;&gt; with open(&#39;best_model.txt&#39;, &#39;rb&#39;) as f:</span>
<span class="sd">    ...     Model = pickle.load(f)</span>
<span class="sd">    ...</span>
<span class="sd">    &gt;&gt;&gt; nasa_norm = Model.norm      # Taking the model&#39;s norm</span>
<span class="sd">    &gt;&gt;&gt; dataset_displot(battery_lists=[</span>
<span class="sd">    ...      [&#39;B0005.txt&#39;], [&#39;B0047.txt&#39;], [&#39;B0001.txt&#39;]</span>
<span class="sd">    ... ], twoD=True, kind=&#39;kde&#39;,</span>
<span class="sd">    ... norm_list=[nasa_norm, nasa_norm, nasa_norm], # datasets normalized with the same norm</span>
<span class="sd">    ... lstm_version=4, delta=10) # LSTM version and delta have to match the norm&#39;s.</span>
<span class="sd">    ... # See Figure 2 for results</span>

<span class="sd">    .. _Figure 1:</span>

<span class="sd">    .. figure:: Images/Figure_1.png</span>
<span class="sd">        :figwidth: 80 %</span>

<span class="sd">        Figure 1: Result of first example.</span>

<span class="sd">    .. _Figure 2:</span>

<span class="sd">    .. figure:: Images/Figure_2.png</span>
<span class="sd">        :figwidth: 80 %</span>

<span class="sd">        Figure 2: Result of the second example.</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="k">for</span> <span class="n">index</span><span class="p">,</span> <span class="n">entry</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">battery_lists</span><span class="p">):</span>
        <span class="k">if</span> <span class="n">entry</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">battery_lists</span><span class="p">[</span><span class="n">index</span><span class="p">]</span> <span class="o">=</span> <span class="p">[</span><span class="s1">&#39;B&#39;</span> <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)</span><span class="o">.</span><span class="n">zfill</span><span class="p">(</span><span class="mi">4</span><span class="p">)</span> <span class="o">+</span> <span class="s1">&#39;.txt&#39;</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">100</span><span class="p">)]</span>

    <span class="n">t_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([[</span><span class="mf">1.</span><span class="p">]])</span>
    <span class="n">Q_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([[</span><span class="mf">1.</span><span class="p">]])</span>
    <span class="n">Name_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([[</span><span class="mf">1.</span><span class="p">]])</span>

    <span class="k">if</span> <span class="n">ignore_dict</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">ignore_dict</span> <span class="o">=</span> <span class="n">main</span><span class="o">.</span><span class="n">ignore_dict</span>

    <span class="k">for</span> <span class="n">index</span><span class="p">,</span> <span class="n">batteries</span> <span class="ow">in</span> <span class="nb">enumerate</span><span class="p">(</span><span class="n">battery_lists</span><span class="p">):</span>

        <span class="n">dataset_name</span> <span class="o">=</span> <span class="n">main</span><span class="o">.</span><span class="n">dataset_dict</span><span class="p">[</span><span class="n">index</span><span class="p">]</span>

        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="n">main</span><span class="o">.</span><span class="n">path_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">])</span>
        <span class="n">ignore</span> <span class="o">=</span> <span class="n">ignore_dict</span><span class="p">[</span><span class="n">dataset_name</span><span class="p">]</span>

        <span class="nb">print</span><span class="p">(</span><span class="n">dataset_name</span><span class="p">)</span>

        <span class="n">file_list</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">listdir</span><span class="p">()</span>
        <span class="n">file_list</span><span class="o">.</span><span class="n">sort</span><span class="p">()</span>
        <span class="n">Train_list</span> <span class="o">=</span> <span class="p">[]</span>
        <span class="k">for</span> <span class="n">file_name</span> <span class="ow">in</span> <span class="n">file_list</span><span class="p">:</span>
            <span class="k">if</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">in</span> <span class="n">ignore</span><span class="p">)</span> <span class="ow">or</span> <span class="p">(</span><span class="n">file_name</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">batteries</span><span class="p">):</span>
                <span class="k">continue</span>
            <span class="k">else</span><span class="p">:</span>
                <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">file_name</span><span class="p">,</span> <span class="s1">&#39;rb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                    <span class="n">Battery</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>

                <span class="n">Train_list</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">Battery</span><span class="p">)</span>

        <span class="n">os</span><span class="o">.</span><span class="n">chdir</span><span class="p">(</span><span class="s1">&#39;../../../../&#39;</span><span class="p">)</span>
        <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">Train_list</span><span class="p">)</span> <span class="o">==</span> <span class="mi">0</span><span class="p">:</span>
            <span class="k">continue</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="n">train_dataset</span> <span class="o">=</span> <span class="n">Torch_Dataset_LSTM</span><span class="p">(</span>
                <span class="n">Train_list</span><span class="p">,</span> <span class="n">delta</span><span class="p">,</span> <span class="n">lstm_version</span><span class="p">,</span> <span class="n">print_bool</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span>
                <span class="n">time_step</span><span class="o">=</span><span class="n">time_step</span><span class="p">,</span> <span class="n">fixed_len</span><span class="o">=</span><span class="n">fixed_len</span><span class="p">,</span> <span class="n">norm_type</span><span class="o">=</span><span class="n">norm_type</span><span class="p">,</span>
                <span class="n">adimensionalize</span><span class="o">=</span><span class="kc">True</span><span class="p">,</span> <span class="n">min_len</span><span class="o">=</span><span class="mi">150</span><span class="p">,</span> <span class="n">cycle_lim</span><span class="o">=</span><span class="n">cycle_lim</span><span class="p">,</span>
                <span class="n">norm</span><span class="o">=</span><span class="n">norm_list</span><span class="p">[</span><span class="n">index</span><span class="p">]</span>
            <span class="p">)</span>

        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;norm =&quot;</span><span class="p">,</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">norm</span><span class="p">)</span>
        <span class="c1"># print(train_dataset.norm)</span>
        <span class="n">Q</span> <span class="o">=</span> <span class="n">train_dataset</span><span class="o">.</span><span class="n">output</span>  <span class="c1"># The output tensor</span>
        <span class="n">Q</span> <span class="o">=</span> <span class="n">Q</span><span class="o">.</span><span class="n">view</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">Q</span><span class="p">),</span> <span class="mi">1</span><span class="p">)</span><span class="o">.</span><span class="n">numpy</span><span class="p">()</span>
        <span class="c1"># Create the correct &quot;time&quot; numbering column</span>
        <span class="n">t</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">linspace</span><span class="p">(</span><span class="mi">1</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">Q</span><span class="p">),</span> <span class="n">num</span><span class="o">=</span><span class="nb">len</span><span class="p">(</span><span class="n">Q</span><span class="p">))</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">Q</span><span class="p">),</span> <span class="mi">1</span><span class="p">)</span>
        <span class="c1"># Dataset Name Column</span>
        <span class="n">Name</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">dataset_name</span><span class="p">]</span> <span class="o">*</span> <span class="nb">len</span><span class="p">(</span><span class="n">t</span><span class="p">))</span><span class="o">.</span><span class="n">reshape</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">t</span><span class="p">),</span> <span class="mi">1</span><span class="p">)</span>

        <span class="n">t_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">t_array</span><span class="p">,</span> <span class="n">t</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
        <span class="n">Q_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">Q_array</span><span class="p">,</span> <span class="n">Q</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>
        <span class="n">Name_array</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">Name_array</span><span class="p">,</span> <span class="n">Name</span><span class="p">],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">0</span><span class="p">)</span>

    <span class="n">data</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">([</span><span class="n">t_array</span><span class="p">[</span><span class="mi">1</span><span class="p">:,</span> <span class="p">:],</span>
                           <span class="n">Q_array</span><span class="p">[</span><span class="mi">1</span><span class="p">:,</span> <span class="p">:]],</span> <span class="n">axis</span><span class="o">=</span><span class="mi">1</span><span class="p">)</span>

    <span class="n">df</span> <span class="o">=</span> <span class="n">pd</span><span class="o">.</span><span class="n">DataFrame</span><span class="p">(</span><span class="n">data</span><span class="o">=</span><span class="n">data</span><span class="p">,</span> <span class="n">columns</span><span class="o">=</span><span class="p">[</span><span class="s1">&#39;t&#39;</span><span class="p">,</span> <span class="s1">&#39;Q&#39;</span><span class="p">])</span>
    <span class="n">df</span><span class="p">[</span><span class="s1">&#39;Name&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="n">Name_array</span><span class="p">[</span><span class="mi">1</span><span class="p">:,</span> <span class="p">:]</span>
    <span class="c1"># I&#39;ve added this separately because otherwise the pd.df would be str</span>

    <span class="c1"># Palette to differentiate between datasets (arbitrary):</span>

    <span class="k">if</span> <span class="n">twoD</span><span class="p">:</span>
        <span class="n">sns_plot</span> <span class="o">=</span> <span class="n">sns</span><span class="o">.</span><span class="n">displot</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">x</span><span class="o">=</span><span class="s1">&#39;t&#39;</span><span class="p">,</span>
                               <span class="n">y</span><span class="o">=</span><span class="s1">&#39;Q&#39;</span><span class="p">,</span>
                               <span class="n">hue</span><span class="o">=</span><span class="s1">&#39;Name&#39;</span><span class="p">,</span> <span class="n">palette</span><span class="o">=</span><span class="n">main</span><span class="o">.</span><span class="n">palette</span><span class="p">,</span>
                               <span class="n">kind</span><span class="o">=</span><span class="n">kind</span><span class="p">,</span>
                               <span class="n">height</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span>
                               <span class="c1"># binwidth=0.01,</span>
                               <span class="n">stat</span><span class="o">=</span><span class="s1">&#39;density&#39;</span><span class="p">,</span> <span class="n">common_norm</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">sns_plot</span> <span class="o">=</span> <span class="n">sns</span><span class="o">.</span><span class="n">displot</span><span class="p">(</span><span class="n">df</span><span class="p">,</span> <span class="n">x</span><span class="o">=</span><span class="s1">&#39;Q&#39;</span><span class="p">,</span>
                               <span class="n">hue</span><span class="o">=</span><span class="s1">&#39;Name&#39;</span><span class="p">,</span> <span class="n">palette</span><span class="o">=</span><span class="n">main</span><span class="o">.</span><span class="n">palette</span><span class="p">,</span>
                               <span class="n">kind</span><span class="o">=</span><span class="n">kind</span><span class="p">,</span>
                               <span class="n">height</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span>
                               <span class="n">aspect</span><span class="o">=</span><span class="mi">5</span><span class="p">,</span>
                               <span class="c1"># binwidth=0.01,</span>
                               <span class="n">stat</span><span class="o">=</span><span class="s1">&#39;density&#39;</span><span class="p">,</span> <span class="n">common_norm</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>

    <span class="k">if</span> <span class="n">image_name</span> <span class="ow">is</span> <span class="ow">not</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">sns_plot</span><span class="o">.</span><span class="n">savefig</span><span class="p">(</span><span class="n">image_name</span><span class="o">+</span><span class="s1">&#39;.png&#39;</span><span class="p">)</span>
        <span class="n">plt</span><span class="o">.</span><span class="n">close</span><span class="p">()</span></div>
</pre></div>

              </div>
              
              
              <div class='prev-next-bottom'>
                

              </div>
              
          </main>
          

      </div>
    </div>
  
  <script src="../_static/js/index.1c5a1a01449ed65a7b51.js"></script>

  <footer class="footer mt-5 mt-md-0">
  <div class="container">
    
    <div class="footer-item">
      <p class="copyright">
    &copy; Copyright 2021, Antonio Rocha Azevedo.<br/>
</p>
    </div>
    
    <div class="footer-item">
      <p class="sphinx-version">
Created using <a href="http://sphinx-doc.org/">Sphinx</a> 4.0.2.<br/>
</p>
    </div>
    
  </div>
</footer>
  </body>
</html>